
D = load('las11t2data.mat');

% Todellinen malli
a = [1, 2];
b = [1, 2];

% % a-1
% a = [1, 2];
% b = [1];

% % a-2
% a = [1, 2];
% b = [2];

% % b-1
% a = [];
% b = [1, 2];

% % b-2
% a = [1];
% b = [1, 2];

% % c-1
% a = [1, 2, 3];
% b = [1, 2];

% % c-2
% a = [1, 2];
% b = [1, 2, 3];

max_delay = max([a, b]);

Y = D.y(1+max_delay:end);
N = numel(Y);

A = zeros(N, numel(a));
for ii = 1:numel(a)
    A(:, ii) = D.y(1+max_delay-a(ii):end-a(ii));
end

B = zeros(N, numel(b));
for ii = 1:numel(b)
    B(:, ii) = D.u(1+max_delay-b(ii):end-b(ii));
end

phi = [A, B];

theta = (phi'*phi)\(phi'*Y);

disp('Parametrien estimaatit')
disp(theta)

figure(1)

res = Y - phi*theta;
subplot(2,2,1);
autocorr(res);
subplot(2,2,3);
crosscorr(res, D.u(1+max_delay:end));

lambda = sqrt(var(res));
COV = lambda^2*inv(phi'*phi);
VAR = diag(COV);
STDEV = sqrt(VAR);
disp('Estimaattien keskihajonta')
disp(STDEV)

p = 1 - abs(2*normcdf(theta./STDEV) - 1);
disp('Estimaattien p-arvo (hypoteesi: arvo = 0)')
disp(p)

% figure(2)
subplot(1, 2, 2)
sys_true = tf([1, -0.6, -0.3], [0.7, 0.3], 1);
a_vec = [1, zeros(1, max_delay)];
for ii = 1:numel(a)
    a_vec(1+a(ii)) = -theta(ii);
end
b_vec = zeros(1, max_delay);
for ii = 1:numel(b)
    b_vec(b(ii)) = theta(numel(a) + ii);
end
b_vec = theta(numel(a)+1:end)';
sys_est = tf(a_vec, b_vec, 1);

bode(sys_true, sys_est)
