function [Dt, Dk] = hank(w, n)

% [Dt, Dk] = hank(w, n)
% Jrjestelmn kertaluvun identifioiminen Hankelin matriisien
% avulla. 
%
% w = impulssivaste, n on kertaluku
% Dt on determinanttien keskiarvo
% Dk on perttisten determinanttien suhde

w = w(2:end); % poistetaan h(0) vektorista

Dt = zeros(n, 1);

% Ilman keskiarvoistusta
Dt(1) = w(1);
for ii = 2:n
  Dt(ii) = det(hankel(w(1:ii), w(ii:(2*ii - 1))));
end

% % Keskiarvoistuksella
% Dt(1) = mean(w(1:end));
% nw = numel(w);
% for ii = 2:n
%   H = zeros(ii);
%   for jj = 1:(nw - 2*ii + 2)
%       H = H + hankel(w(jj:(jj + ii - 1)),...
%         w((jj + ii - 1):(jj + 2*ii - 2)));
%   end
%   Dt(ii) = det(H/(nw - 2*ii + 2));
% end

Dk = abs(Dt(1:end-1)./Dt(2:end));
