function [rang, deter] = prodmom(u, y, m)
% jrjestelmn kertaluvun identifioiminen tulomomentti-
% matriisin avulla. Hakee maksimin osoittajan ja nimittjn
% kertaluvuista, kun kuollut aika on nolla.
%  [rang,deter,Dk]=prodmom(u,x,m)
% missa u on sisaanmenovektori
%       y on ulostulovektori
%       m on viive jolle asti halutaan tutkia
%       rang on Q-matriisien rankit sisaltava vektori
%       deter on Q-matriisien determinantit sis. vektori

% Havaintovektoreiden pituudet:
N = length(u)-m;
% Tulomomenttimatriisi kertaluvulle 1:
Q = [y(1:N)'*y(1:N)/N, y(1:N)'*u(1:N)/N;
    u(1:N)'*y(1:N)/N, u(1:N)'*u(1:N)/N];
rang = zeros(1, m);
rang(1) = rank(Q);
deter = zeros(1, m);
deter(1) = det(Q);
%
for n = 2:m
    % Tulomomenttimatriisin pivitys kertaluvusta n-1 kertalukuun n:
    % siirretn edellisen matriisin blokit uusille paikoille:
    Q(n+2:2*n, n+2:2*n) = Q(n:2*n-2, n:2*n-2); %oikea alakulma
    Q(2:n, n+2:2*n)     = Q(1:n-1, n:2*n-2);   %oikea ylkulma
    Q(n+2:2*n, 2:n)     = Q(n:2*n-2, 1:n-1);   %vasen alakulma
    Q(2:n, 2:n)         = Q(1:n-1, 1:n-1);     %vasen ylkulma
    % listn pysty- ja vaakavektorit 1 ja n+1:
    for ii = 1:n
        %   pysty- ja vaakavektorit 1:
        Q(ii, 1)   = y(n:N+n-1)'*y(n-ii+1:N+n-ii)/N;
        Q(1, ii)   = Q(ii, 1);
        Q(n+ii, 1) = y(n:N+n-1)'*u(n-ii+1:N+n-ii)/N;
        Q(1, n+ii) = Q(n+ii, 1);
        %   pysty- ja vaakavektorit n+1:
        Q(ii, n+1)   = u(n:N+n-1)'*y(n-ii+1:N+n-ii)/N;
        Q(n+1, ii)   = Q(ii, n+1);
        Q(n+ii, n+1) = u(n:N+n-1)'*u(n-ii+1:N+n-ii)/N;
        Q(n+1, n+ii) = Q(n+ii, n+1);
    end
    
    rang(n) = rank(Q);
    deter(n) = det(Q);
end
